"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var use_force_update_1 = require("use-force-update");
var react_1 = require("react");
function useRxJs(observableSelector) {
    var value$ = useObservableSelector(observableSelector);
    var valueRef = react_1.useRef(null);
    var forceUpdate = use_force_update_1.default();
    var isFirstRenderRef = useIsFirstRenderRef();
    var subscribe = function () {
        return value$.subscribe(function (value) {
            valueRef.current = value;
            if (!isFirstRenderRef.current) {
                forceUpdate();
            }
        });
    };
    var initialSub = isFirstRenderRef.current && subscribe();
    react_1.useEffect(function () {
        var sub = initialSub || subscribe();
        return function () { return sub.unsubscribe(); };
    }, [value$]);
    return valueRef.current;
}
exports.useRxJs = useRxJs;
function useObservableSelector(observableSelector) {
    return typeof observableSelector === "function"
        ? useInstance(observableSelector)
        : observableSelector;
}
function useInstance(initializer) {
    var instanceRef = React.useRef(null);
    if (instanceRef.current === null) {
        instanceRef.current = initializer();
    }
    return instanceRef.current;
}
exports.useInstance = useInstance;
function useIsFirstRenderRef() {
    var ref = React.useRef(true);
    react_1.useEffect(function () {
        ref.current = false;
    }, []);
    return ref;
}
exports.default = useRxJs;
//# sourceMappingURL=index.js.map